/**
 * Created February 1, 2023
 */

#ifndef GS_Error_H
#define GS_Error_H

#pragma once

#define GS_ERROR_HTTP_CODE_UNDEFINED -1000
#define GS_ERROR_RANGE -100

/// TCP client errors
#define GS_ERROR_TCP_ERROR_CONNECTION_REFUSED (-1)
#define GS_ERROR_TCP_ERROR_SEND_REQUEST_FAILED (-2)
#define GS_ERROR_TCP_ERROR_NOT_CONNECTED (-3)
#define GS_ERROR_TCP_ERROR_CONNECTION_LOST (-4)
#define GS_ERROR_TCP_ERROR_NO_STREAM (-5)
#define GS_ERROR_TCP_ERROR_NO_HTTP_SERVER (-6)
#define GS_ERROR_TCP_ERROR_TOO_LESS_RAM (-7)
#define GS_ERROR_TCP_ERROR_ENCODING (-8)
#define GS_ERROR_TCP_ERROR_STREAM_WRITE (-9)
#define GS_ERROR_TCP_ERROR_CONNECTION_INUSED (-10)
#define GS_ERROR_TCP_RESPONSE_PAYLOAD_READ_TIMED_OUT (-11)
#define GS_ERROR_TCP_RESPONSE_READ_FAILED (-12)


/// HTTP codes see RFC7231
#define GS_ERROR_HTTP_CODE_OK 200
#define GS_ERROR_HTTP_CODE_NON_AUTHORITATIVE_INFORMATION 203
#define GS_ERROR_HTTP_CODE_NO_CONTENT 204
#define GS_ERROR_HTTP_CODE_MOVED_PERMANENTLY 301
#define GS_ERROR_HTTP_CODE_FOUND 302
#define GS_ERROR_HTTP_CODE_USE_PROXY 305
#define GS_ERROR_HTTP_CODE_TEMPORARY_REDIRECT 307
#define GS_ERROR_HTTP_CODE_PERMANENT_REDIRECT 308
#define GS_ERROR_HTTP_CODE_BAD_REQUEST 400
#define GS_ERROR_HTTP_CODE_UNAUTHORIZED 401
#define GS_ERROR_HTTP_CODE_FORBIDDEN 403
#define GS_ERROR_HTTP_CODE_NOT_FOUND 404
#define GS_ERROR_HTTP_CODE_METHOD_NOT_ALLOWED 405
#define GS_ERROR_HTTP_CODE_NOT_ACCEPTABLE 406
#define GS_ERROR_HTTP_CODE_PROXY_AUTHENTICATION_REQUIRED 407
#define GS_ERROR_HTTP_CODE_REQUEST_TIMEOUT 408
#define GS_ERROR_HTTP_CODE_LENGTH_REQUIRED 411
#define GS_ERROR_HTTP_CODE_PRECONDITION_FAILED 412
#define GS_ERROR_HTTP_CODE_PAYLOAD_TOO_LARGE 413
#define GS_ERROR_HTTP_CODE_URI_TOO_LONG 414
#define GS_ERROR_HTTP_CODE_MISDIRECTED_REQUEST 421
#define GS_ERROR_HTTP_CODE_UNPROCESSABLE_ENTITY 422
#define GS_ERROR_HTTP_CODE_TOO_MANY_REQUESTS 429
#define GS_ERROR_HTTP_CODE_REQUEST_HEADER_FIELDS_TOO_LARGE 431
#define GS_ERROR_HTTP_CODE_INTERNAL_SERVER_ERROR 500
#define GS_ERROR_HTTP_CODE_NOT_IMPLEMENTED 501
#define GS_ERROR_HTTP_CODE_BAD_GATEWAY 502
#define GS_ERROR_HTTP_CODE_SERVICE_UNAVAILABLE 503
#define GS_ERROR_HTTP_CODE_GATEWAY_TIMEOUT 504
#define GS_ERROR_HTTP_CODE_HTTP_VERSION_NOT_SUPPORTED 505
#define GS_ERROR_HTTP_CODE_LOOP_DETECTED 508
#define GS_ERROR_HTTP_CODE_NETWORK_AUTHENTICATION_REQUIRED 511

// Gsheet error
#define GS_ERROR_BUFFER_OVERFLOW /*          */ (GS_ERROR_RANGE - 1)
#define GS_ERROR_DATA_TYPE_MISMATCH /*          */ (GS_ERROR_RANGE - 2)
#define GS_ERROR_PATH_NOT_EXIST /*          */ (GS_ERROR_RANGE - 3)
#define GS_ERROR_EXTERNAL_CLIENT_DISABLED /*          */ (GS_ERROR_RANGE - 4)
#define GS_ERROR_EXTERNAL_CLIENT_NOT_INITIALIZED /*          */ (GS_ERROR_RANGE - 5)
#define GS_ERROR_TOKEN_SET_TIME /*          */ (GS_ERROR_RANGE - 6)
#define GS_ERROR_TOKEN_CREATE_HASH /*          */ (GS_ERROR_RANGE - 7)
#define GS_ERROR_TOKEN_PARSE_PK /*          */ (GS_ERROR_RANGE - 8)
#define GS_ERROR_TOKEN_SIGN /*          */ (GS_ERROR_RANGE - 9)
#define GS_ERROR_TOKEN_EXCHANGE /*          */ (GS_ERROR_RANGE - 10)
#define GS_ERROR_TOKEN_NOT_READY /*          */ (GS_ERROR_RANGE - 11)
#define GS_ERROR_SYS_TIME_IS_NOT_READY /*          */ (GS_ERROR_RANGE - 12)
#define GS_ERROR_NTP_SYNC_TIMED_OUT /*          */ (GS_ERROR_RANGE - 13)
#define GS_ERROR_TOKEN_COMPLETE_NOTIFY /*          */ (GS_ERROR_RANGE - 14)
#define GS_ERROR_TOKEN_COMPLETE_UNNOTIFY /*          */ (GS_ERROR_RANGE - 15)
#define GS_ERROR_TOKEN_ERROR_UNNOTIFY /*          */ (GS_ERROR_RANGE - 16)
#define GS_ERROR_UDP_CLIENT_REQUIRED /*          */ (GS_ERROR_RANGE - 17)
#define GS_ERROR_MISSING_SERVICE_ACCOUNT_CREDENTIALS /*          */ (GS_ERROR_RANGE - 18)
#define GS_ERROR_SERVICE_ACCOUNT_JSON_FILE_PARSING_ERROR /*          */ (GS_ERROR_RANGE - 19)
#endif